/********************************COPYRIGHT*************************************

    Copyright (C) 2002 - 2005 Brendt Wohlberg  <software@wohlberg.net>

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of the
    License, or (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this library; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

********************************COPYRIGHT*************************************/

/*
  TIFF directory access functions

  Most recent modification: 19 February 2005
*/

#ifndef _TIFFDIR_H
#define _TIFFDIR_H

#include "tiffio.h" 

#ifdef WORDS_BIGENDIAN
#define REQUIRE_ENDIAN_CORRECTION(mgk) (mgk == TIFF_LITTLEENDIAN)
#else
#define REQUIRE_ENDIAN_CORRECTION(mgk) (mgk == TIFF_BIGENDIAN)
#endif

void InitialDirEntrySwab(TIFFDirEntry* tdep, int swabflag);

int DirEntrySize(TIFFDirEntry* tdep);

void* DirEntryValue(TIFFDirEntry* tdep, FILE* fp, int swabflag);

TIFFDirEntry* OpenDirectory(FILE* fp, uint32 diroff, uint16* ndep, 
			   int swabflag);

void CloseDirectory(TIFFDirEntry* tdep);

TIFFDirEntry* TagDirEntry(TIFFDirEntry* tdep, uint16 nde, uint16 tag);

void* TagValue(TIFFDirEntry* tdep, uint16 nde, FILE* fp, uint16 tag, 
	       int swabflag);

TIFFDirEntry* OpenMakerNote(FILE* fp, uint32 diroff, uint16* ndep, 
			    uint32* thop, int swabflag);

#endif
